#include "fxlib.h"
#include "stdlib.h" //pour les fonctions quivalentes  Int et Ran#
#include "stdio.h" //pour la fonction sprintf (j'explique aprs  quoi elle sert)
#include "libg85.c"

int a,b,c,d,i,j,e,f,score,g,tp,tp2,perdu,controle_ok,difficult;
int tab[32][14]; //correspond  la matrice de dplacement du snake
char affichage[21]; //servira pour sprintf
unsigned int key;

void boucle(){
	if(perdu==0){
		controle_ok=0;
		//dplace les coordonnes du snake (mais ne le dessine pas)
		if(g==2){a++;if(a>31)a=0;}
		if(g==1){b++;if(b>13)b=0;}
		if(g==0){if(a<1)a=32;a--;}
		if(g==3){if(b<1)b=14;b--;}
		controle_ok=1;
	}
	//Si on se mord la queue
	if(tab[a][b]>0){perdu=1;}
	else{

		//On appele le sous prog pour dessiner un rond (du serpent)
		aff_serpent(a,b);
		tab[a][b]=i; //On rempli la case de la matrice pour dire qu'il y a qqchose dedans
		i++;

		//Si on bouffe une croix :p
		if(a==e && b==f){
			while(tab[e][f]>0){ //on verif que la nouvelle croix n'est pas directement sur le serpent
				e=1+(int)((float)rand()*31/(RAND_MAX+1)); //Tire un nombre alatoire compris en 1 et 31
				f=1+(int)((float)rand()*13/(RAND_MAX+1));
			}
			aff_croix(e,f); //Pour afficher la nouvelle croix
			score+=3*difficult; //Equivaut  score=score+10;
		}
		else{
			//On regarde o se trouve la fin de la queue pour l'effacer
			tp=c+1;
			if(tp>31)tp=0;
			if(tab[tp][d]==j)c=tp;
			tp=c-1;
			if(tp<0)tp=31;
			if(tab[tp][d]==j)c=tp;
			tp=d+1;
			if(tp>13)tp=0;
			if(tab[c][tp]==j)d=tp;
			tp=d-1;
			if(tp<0)tp=13;
			if(tab[c][tp]==j)d=tp;

			eff_serpent(c,d); //On efface la queue
			tab[c][d]=0; //On vide la case de la matrice
			j++;
		}

		sprintf(affichage,"Score : %d",score);
		locate(10,8);
		Print(affichage); //On affiche le score
		Bdisp_PutDisp_DD(); //On met  jour l'image
	}
}

int AddIn_main(int isAppli, unsigned short OptionNum)
{
	Bdisp_AllClr_DDVRAM(); //Efface l'cran
	intro(); //Appele d'un sous prog pour l'introduction
	difficult=input(affichage,"Difficulty (1-9)");
	if(difficult>9)difficult=9;
	if(difficult<1)difficult=1;
	Bdisp_AllClr_DDVRAM();

	while(1){
		Bdisp_AllClr_DDVRAM();
		load(); //Appele d'un sous prog pour initialiser les valeurs
		SetTimer(1,(int)(300/difficult),boucle); //La boucle principal (o le snake se dplace) sera execut toutes les 100ms
		controle();
		//Reviens ici quand c'est fini

		Bdisp_AllClr_DDVRAM();
		imagesnake(); //Importe l'image du snake
		locate(1,1);
		Print("You lose !");

		//La fonction sprintf sert  afficher des variables.
		sprintf(affichage,"Score : %d",score);
		//Le texte va tre enregistrer dans le tableau affichage (qui doit avoir une dimension suprieur au nombre de caractres).
		//%d veut dire qu'on veut mettre la variable score  cet endroit. Ex: sprintf(affichage,"Il est %d h %d min",heure,minute);
		locate(1,2);
		Print(affichage); //puis on l'affiche

		PrintMini(70,58,"AC/on to leave",0); //Affiche en petit
		Bdisp_PutDisp_DD();
		for(tp=0;tp<10000;tp++)if(IsKeyDown(KEY_CTRL_AC))return 1;
	}

	return 1;
}

controle(){
	tp2=1;
	while(1){
		if(controle_ok)tp2=1;

		GetKey(&key);
		if(key==KEY_CTRL_AC || perdu){KillTimer(1);return;} //Pour quitter

		//contrle les mouvements autoriss
		if(tp2 && key==KEY_CTRL_LEFT && g!=2 && g!=0){g=0;tp2=0;}
		if(tp2 && key==KEY_CTRL_RIGHT && g!=0 && g!=2){g=2;tp2=0;}
		if(tp2 && key==KEY_CTRL_UP && g!=1 && g!=3){g=3;tp2=0;}
		if(tp2 && key==KEY_CTRL_DOWN && g!=3 && g!=1){g=1;tp2=0;}
	}
}

load(){
	for (i=0;i<32;i++)for (j=0;j<14;j++)tab[i][j]=0;
	tab[3][3]=2;
	tab[4][3]=3;
	tab[5][3]=4;
	a=5;
	b=3;
	c=2;
	d=3;
	i=5;
	j=2;
	score=0;
	g=2;
	e=5;
	f=5;
	perdu=0;

	aff_serpent(3,3);
	aff_serpent(4,3);
	aff_serpent(5,3);
	aff_croix(5,5);
}

aff_serpent(int x,int y){
	x=4*x+1;
	y=4*y+1;
	Bdisp_DrawLineVRAM(x+1,y,x+2,y);
	Bdisp_DrawLineVRAM(x,y+1,x+3,y+1);
	Bdisp_DrawLineVRAM(x,y+2,x+3,y+2);
	Bdisp_DrawLineVRAM(x+1,y+3,x+2,y+3);	
}

eff_serpent(int x,int y){
	x=4*x+1;
	y=4*y+1;
	Bdisp_ClearLineVRAM(x,y,x+3,y);
	Bdisp_ClearLineVRAM(x,y+1,x+3,y+1);
	Bdisp_ClearLineVRAM(x,y+2,x+3,y+2);
	Bdisp_ClearLineVRAM(x,y+3,x+3,y+3);	
}


aff_croix(int x,int y){
	x=4*x+1;
	y=4*y+1;
	Bdisp_DrawLineVRAM(x,y,x+3,y+3);
	Bdisp_DrawLineVRAM(x,y+3,x+3,y);	
}

intro(){
Bdisp_DrawLineVRAM(27,9,35,9);
Bdisp_DrawLineVRAM(68,9,75,9);
Bdisp_DrawLineVRAM(24,10,41,10);
Bdisp_DrawLineVRAM(61,10,67,10);
Bdisp_DrawLineVRAM(76,10,83,10);
Bdisp_DrawLineVRAM(21,11,46,11);
Bdisp_DrawLineVRAM(57,11,60,11);
Bdisp_DrawLineVRAM(83,11,84,11);
Bdisp_DrawLineVRAM(20,12,34,12);
Bdisp_DrawLineVRAM(39,12,50,12);
Bdisp_DrawLineVRAM(55,12,56,12);
Bdisp_DrawLineVRAM(85,12,87,12);
Bdisp_DrawLineVRAM(19,13,27,13);
Bdisp_DrawLineVRAM(49,13,55,13);
Bdisp_DrawLineVRAM(86,13,89,13);
Bdisp_DrawLineVRAM(19,14,25,14);
Bdisp_SetPoint_VRAM(49,14,1);
Bdisp_DrawLineVRAM(54,14,58,14);
Bdisp_DrawLineVRAM(87,14,90,14);
Bdisp_DrawLineVRAM(19,15,26,15);
Bdisp_DrawLineVRAM(47,15,48,15);
Bdisp_DrawLineVRAM(57,15,61,15);
Bdisp_DrawLineVRAM(88,15,92,15);
Bdisp_DrawLineVRAM(18,16,27,16);
Bdisp_SetPoint_VRAM(46,16,1);
Bdisp_DrawLineVRAM(53,16,68,16);
Bdisp_DrawLineVRAM(89,16,93,16);
Bdisp_DrawLineVRAM(18,17,28,17);
Bdisp_SetPoint_VRAM(45,17,1);
Bdisp_DrawLineVRAM(50,17,71,17);
Bdisp_DrawLineVRAM(91,17,93,17);
Bdisp_DrawLineVRAM(18,18,29,18);
Bdisp_DrawLineVRAM(43,18,44,18);
Bdisp_DrawLineVRAM(49,18,60,18);
Bdisp_DrawLineVRAM(67,18,72,18);
Bdisp_DrawLineVRAM(92,18,94,18);
Bdisp_DrawLineVRAM(19,19,30,19);
Bdisp_SetPoint_VRAM(42,19,1);
Bdisp_DrawLineVRAM(49,19,54,19);
Bdisp_DrawLineVRAM(67,19,73,19);
Bdisp_DrawLineVRAM(92,19,94,19);
Bdisp_DrawLineVRAM(19,20,31,20);
Bdisp_SetPoint_VRAM(41,20,1);
Bdisp_DrawLineVRAM(49,20,54,20);
Bdisp_DrawLineVRAM(66,20,71,20);
Bdisp_DrawLineVRAM(74,20,75,20);
Bdisp_DrawLineVRAM(93,20,95,20);
Bdisp_DrawLineVRAM(20,21,33,21);
Bdisp_SetPoint_VRAM(40,21,1);
Bdisp_DrawLineVRAM(49,21,71,21);
Bdisp_DrawLineVRAM(76,21,78,21);
Bdisp_DrawLineVRAM(93,21,95,21);
Bdisp_DrawLineVRAM(20,22,35,22);
Bdisp_SetPoint_VRAM(39,22,1);
Bdisp_DrawLineVRAM(49,22,69,22);
Bdisp_DrawLineVRAM(78,22,80,22);
Bdisp_DrawLineVRAM(93,22,95,22);
Bdisp_DrawLineVRAM(21,23,36,23);
Bdisp_SetPoint_VRAM(38,23,1);
Bdisp_DrawLineVRAM(49,23,60,23);
Bdisp_DrawLineVRAM(81,23,82,23);
Bdisp_DrawLineVRAM(93,23,95,23);
Bdisp_DrawLineVRAM(23,24,38,24);
Bdisp_DrawLineVRAM(49,24,54,24);
Bdisp_DrawLineVRAM(83,24,84,24);
Bdisp_DrawLineVRAM(93,24,95,24);
Bdisp_DrawLineVRAM(24,25,40,25);
Bdisp_DrawLineVRAM(49,25,54,25);
Bdisp_DrawLineVRAM(62,25,73,25);
Bdisp_DrawLineVRAM(85,25,86,25);
Bdisp_DrawLineVRAM(93,25,94,25);
Bdisp_DrawLineVRAM(25,26,42,26);
Bdisp_DrawLineVRAM(49,26,54,26);
Bdisp_DrawLineVRAM(60,26,76,26);
Bdisp_DrawLineVRAM(87,26,88,26);
Bdisp_DrawLineVRAM(92,26,94,26);
Bdisp_DrawLineVRAM(26,27,44,27);
Bdisp_DrawLineVRAM(49,27,54,27);
Bdisp_DrawLineVRAM(59,27,76,27);
Bdisp_DrawLineVRAM(88,27,90,27);
Bdisp_DrawLineVRAM(92,27,93,27);
Bdisp_DrawLineVRAM(27,28,46,28);
Bdisp_DrawLineVRAM(50,28,54,28);
Bdisp_DrawLineVRAM(59,28,64,28);
Bdisp_DrawLineVRAM(74,28,76,28);
Bdisp_DrawLineVRAM(90,28,93,28);
Bdisp_DrawLineVRAM(29,29,48,29);
Bdisp_DrawLineVRAM(58,29,63,29);
Bdisp_DrawLineVRAM(91,29,93,29);
Bdisp_DrawLineVRAM(30,30,50,30);
Bdisp_DrawLineVRAM(58,30,63,30);
Bdisp_DrawLineVRAM(71,30,73,30);
Bdisp_DrawLineVRAM(90,30,91,30);
Bdisp_DrawLineVRAM(93,30,94,30);
Bdisp_DrawLineVRAM(32,31,53,31);
Bdisp_DrawLineVRAM(58,31,63,31);
Bdisp_DrawLineVRAM(70,31,76,31);
Bdisp_DrawLineVRAM(89,31,90,31);
Bdisp_DrawLineVRAM(94,31,96,31);
Bdisp_DrawLineVRAM(32,32,53,32);
Bdisp_DrawLineVRAM(58,32,63,32);
Bdisp_DrawLineVRAM(70,32,76,32);
Bdisp_DrawLineVRAM(89,32,90,32);
Bdisp_DrawLineVRAM(94,32,96,32);
Bdisp_DrawLineVRAM(34,33,55,33);
Bdisp_DrawLineVRAM(59,33,76,33);
Bdisp_DrawLineVRAM(87,33,89,33);
Bdisp_DrawLineVRAM(95,33,97,33);
Bdisp_DrawLineVRAM(35,34,74,34);
Bdisp_DrawLineVRAM(86,34,88,34);
Bdisp_DrawLineVRAM(96,34,98,34);
Bdisp_DrawLineVRAM(36,35,60,35);
Bdisp_DrawLineVRAM(62,35,72,35);
Bdisp_DrawLineVRAM(85,35,87,35);
Bdisp_DrawLineVRAM(97,35,99,35);
Bdisp_DrawLineVRAM(36,36,63,36);
Bdisp_DrawLineVRAM(83,36,86,36);
Bdisp_DrawLineVRAM(98,36,100,36);
Bdisp_DrawLineVRAM(37,37,40,37);
Bdisp_DrawLineVRAM(42,37,66,37);
Bdisp_DrawLineVRAM(81,37,84,37);
Bdisp_DrawLineVRAM(99,37,101,37);
Bdisp_DrawLineVRAM(37,38,41,38);
Bdisp_DrawLineVRAM(44,38,69,38);
Bdisp_DrawLineVRAM(79,38,83,38);
Bdisp_DrawLineVRAM(99,38,102,38);
Bdisp_DrawLineVRAM(38,39,43,39);
Bdisp_DrawLineVRAM(47,39,73,39);
Bdisp_DrawLineVRAM(76,39,81,39);
Bdisp_DrawLineVRAM(99,39,102,39);
Bdisp_DrawLineVRAM(40,40,45,40);
Bdisp_DrawLineVRAM(49,40,79,40);
Bdisp_DrawLineVRAM(99,40,103,40);
Bdisp_DrawLineVRAM(41,41,47,41);
Bdisp_DrawLineVRAM(52,41,81,41);
Bdisp_DrawLineVRAM(99,41,103,41);
Bdisp_DrawLineVRAM(44,42,52,42);
Bdisp_DrawLineVRAM(56,42,86,42);
Bdisp_DrawLineVRAM(98,42,103,42);
Bdisp_DrawLineVRAM(47,43,102,43);
Bdisp_DrawLineVRAM(52,44,101,44);
Bdisp_DrawLineVRAM(67,45,70,45);
Bdisp_DrawLineVRAM(72,45,100,45);
Bdisp_DrawLineVRAM(73,46,97,46);
Bdisp_DrawLineVRAM(81,47,92,47);
locate(1,8);
Print("Planet-Casio Presents");
Bdisp_PutDisp_DD();
Sleep(2000);
Bdisp_AllClr_DDVRAM();

imagesnake();
locate(3,2);
Print("Snake");
locate(11,8);
Print("By Muelsaco");
Bdisp_PutDisp_DD();
Sleep(3000);
}

imagesnake(){
Bdisp_DrawLineVRAM(73,3,76,3);
Bdisp_DrawLineVRAM(64,4,82,4);
Bdisp_DrawLineVRAM(63,5,73,5);
Bdisp_DrawLineVRAM(77,5,89,5);
Bdisp_DrawLineVRAM(60,6,91,6);
Bdisp_DrawLineVRAM(57,7,60,7);
Bdisp_DrawLineVRAM(64,7,92,7);
Bdisp_DrawLineVRAM(49,8,52,8);
Bdisp_SetPoint_VRAM(57,8,1);
Bdisp_DrawLineVRAM(64,8,92,8);
Bdisp_DrawLineVRAM(53,9,55,9);
Bdisp_DrawLineVRAM(68,9,92,9);
Bdisp_DrawLineVRAM(76,10,91,10);
Bdisp_DrawLineVRAM(77,11,90,11);
Bdisp_DrawLineVRAM(77,12,89,12);
Bdisp_DrawLineVRAM(77,13,88,13);
Bdisp_DrawLineVRAM(74,14,88,14);
Bdisp_DrawLineVRAM(70,15,87,15);
Bdisp_DrawLineVRAM(66,16,86,16);
Bdisp_DrawLineVRAM(64,17,84,17);
Bdisp_DrawLineVRAM(61,18,82,18);
Bdisp_DrawLineVRAM(60,19,79,19);
Bdisp_DrawLineVRAM(58,20,75,20);
Bdisp_DrawLineVRAM(57,21,71,21);
Bdisp_DrawLineVRAM(56,22,69,22);
Bdisp_DrawLineVRAM(55,23,68,23);
Bdisp_DrawLineVRAM(54,24,68,24);
Bdisp_DrawLineVRAM(54,25,68,25);
Bdisp_DrawLineVRAM(54,26,69,26);
Bdisp_DrawLineVRAM(54,27,70,27);
Bdisp_DrawLineVRAM(54,28,73,28);
Bdisp_DrawLineVRAM(55,29,78,29);
Bdisp_DrawLineVRAM(40,30,41,30);
Bdisp_DrawLineVRAM(56,30,82,30);
Bdisp_DrawLineVRAM(41,31,42,31);
Bdisp_DrawLineVRAM(58,31,86,31);
Bdisp_DrawLineVRAM(41,32,42,32);
Bdisp_DrawLineVRAM(60,32,89,32);
Bdisp_DrawLineVRAM(39,33,41,33);
Bdisp_DrawLineVRAM(62,33,91,33);
Bdisp_DrawLineVRAM(37,34,41,34);
Bdisp_DrawLineVRAM(65,34,92,34);
Bdisp_DrawLineVRAM(34,35,39,35);
Bdisp_DrawLineVRAM(70,35,93,35);
Bdisp_DrawLineVRAM(32,36,37,36);
Bdisp_DrawLineVRAM(73,36,93,36);
Bdisp_DrawLineVRAM(29,37,35,37);
Bdisp_DrawLineVRAM(76,37,93,37);
Bdisp_DrawLineVRAM(28,38,34,38);
Bdisp_DrawLineVRAM(76,38,93,38);
Bdisp_DrawLineVRAM(28,39,34,39);
Bdisp_DrawLineVRAM(74,39,102,39);
Bdisp_DrawLineVRAM(28,40,106,40);
Bdisp_DrawLineVRAM(28,41,108,41);
Bdisp_DrawLineVRAM(28,42,108,42);
Bdisp_DrawLineVRAM(27,43,108,43);
Bdisp_DrawLineVRAM(18,44,108,44);
Bdisp_DrawLineVRAM(16,45,108,45);
Bdisp_DrawLineVRAM(16,46,108,46);
Bdisp_DrawLineVRAM(15,47,108,47);
Bdisp_DrawLineVRAM(15,48,107,48);
Bdisp_DrawLineVRAM(15,49,111,49);
Bdisp_DrawLineVRAM(10,50,122,50);
Bdisp_DrawLineVRAM(7,51,123,51);
Bdisp_DrawLineVRAM(6,52,124,52);
Bdisp_DrawLineVRAM(5,53,124,53);
Bdisp_DrawLineVRAM(5,54,124,54);
Bdisp_DrawLineVRAM(5,55,124,55);
Bdisp_DrawLineVRAM(5,56,124,56);
Bdisp_DrawLineVRAM(5,57,124,57);
Bdisp_DrawLineVRAM(5,58,123,58);
Bdisp_DrawLineVRAM(6,59,59,59);
Bdisp_DrawLineVRAM(89,59,123,59);
Bdisp_DrawLineVRAM(8,60,44,60);
Bdisp_DrawLineVRAM(101,60,122,60);
Bdisp_DrawLineVRAM(11,61,30,61);
Bdisp_DrawLineVRAM(113,61,120,61);
}

//A NE PAS TOUCHER
#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum){return INIT_ADDIN_APPLICATION(isAppli, OptionNum);}
#pragma section

